#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include "histogam.h"
#include "text.h"
#include "svg.h"
#include <conio.h>
#include "histogam_internal.h"
#include <curl/curl.h>
#include <sstream>
#include <string>
using namespace std;



/*struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    size_t number_count;
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);

    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }

    cerr<< "Enter number of bins";
    cin >> in.bin_count;
    return in;
}

int main()
{
    Input in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    double min, max;
    find_minmax(in.numbers,min,max);
    show_histogram_svg(bins,min,max);
    return 0;
    }
*/
struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data(istream& in, bool promt)
{
    size_t number_count;
     if (promt)
    {
        cerr << "Enter number count: ";
    }
    in >> number_count;
    Input ik;
    ik.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++)
    {
        in >> ik.numbers[i];
    }
    cerr << "Enter bin count: ";
    in>> ik.bin_count;
    return ik;
}

size_t write_data(void* items, size_t item_size, size_t item_count, void* ctx)
{
    size_t data_size = item_size * item_count;
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    buffer->write(static_cast<const char*>(items), data_size);
    return 0;
}


Input
download(const string& address)
{
stringstream buffer;
    CURL *curl = curl_easy_init();
    if(curl)
    {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
        curl_easy_cleanup(curl);
        if (res != CURLE_OK)
        {
            cout << curl_easy_strerror;
            exit(1);
        }
    }
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);

    return input_data(buffer, false);
}


int main(int argc, char* argv[])
{
    Input input;
    if (argc > 1)
    {
        input = download(argv[1]);
    }
    else
    {
        input = input_data(cin, true);
    }

    const auto bins = make_histogram(input.numbers, input.bin_count);
    show_histogram_svg(bins);
}
